<?php

if (! function_exists('setting'))
{
    /*
     * 获取配置
     */
    function setting($key,$pid=null)
    {
        $paramsObj=paramsObj();
        $paramsObj->params=array(
            "itemKey"=>$key,
        );
        if (isset($pid)){
            $paramsObj->params["pid"]=$pid;
        }
        $checkResult=app("L_Common_caches")->getSetting($paramsObj);
        if($checkResult["error_no"]=="0"){
            return $checkResult["result"];
        }
        return "";
    }
}

if (! function_exists('siteSetting'))
{
    /*
     * 获取网站配置
     */
    function siteSetting($key)
    {
        return setting($key,1);
    }
}

if (! function_exists('seoSetting'))
{
    /*
     * 获取网站seo配置
     */
    function seoSetting($key)
    {
        return setting($key,2);
    }
}

if (! function_exists('extendSetting'))
{
    /*
     * 获取扩展配置
     */
    function extendSetting($key)
    {
        return setting($key,4);
    }
}

if (! function_exists('xnSetting'))
{
    /*
     * 获取性能优化配置
     */
    function xnSetting($key)
    {
        return setting($key,3);
    }
}

if (! function_exists('module'))
{
    /*
     * 获取模块数据
     */
    function module($id="",$key="",$print=false)
    {
        $paramsObj=paramsObj();
        $paramsObj->params=array(
            "id"=>$id,
            "print"=>$print,
            "itemKey"=>$key,
        );
        $checkResult=app("L_Common_caches")->getModule($paramsObj);
        if($checkResult["error_no"]=="0"){
            return $checkResult["result"];
        }
        return "";
    }
}

if (! function_exists('category'))
{
    /*
     * 获取模块数据
     */
    function category($dataType="",$dataId="",$key="",$print=false)
    {
        $paramsObj=paramsObj();
        $paramsObj->params=array(
            "dataType"=>$dataType,
            "dataId"=>$dataId,
            "print"=>$print,
            "itemKey"=>$key,
        );
        $checkResult=app("L_Common_caches")->getCategory($paramsObj);
        if($checkResult["error_no"]=="0"){
            return $checkResult["result"];
        }
        return "";
    }
}

if (! function_exists('upPhpConfig'))
{
    /*
     * 更新配置文件
     */
    function upPhpConfig($upConfig)
    {
        if($upConfig && is_array($upConfig)){
            $config=array();
            foreach($upConfig as $key=>$val){
                $config=setData($key,$val,$config);
            }
            $configDirPath=LTCMS_ROOT."/custom/config";
            makeDir($configDirPath);
            foreach($config as $file=>$val){
                $configFile=$configDirPath."/{$file}.php";
                $fileMap=is_file($configFile)?include $configFile:array();
                //合并数据
                $mergeData=mergeArr($fileMap,$val);
                $fileCode="<?php\n\n \$config= ".var_export($mergeData,true).";\nreturn \$config;";
                file_put_contents($configFile,$fileCode);
            }
        }
    }
}

if (! function_exists('upModuleCache'))
{
    /*
     * 更新模块缓存
     */
    function upModuleCache($moduleId)
    {
        if($moduleId){
            $paramsObj=paramsObj();
            $paramsObj->params=array(
                "id"=>$moduleId,
            );
            $tmp=app("L_Common_caches")->updateModule($paramsObj);
            if($tmp["error_no"]){
                recordErrorLog($tmp); //记录错误信息
            }
        }
    }
}

if (! function_exists('upSettingCache'))
{
    /*
     * 更新设置缓存
     */
    function upSettingCache($moduleId)
    {
        if($moduleId){
            $paramsObj=paramsObj();
            $paramsObj->params=array(
                "pid"=>$moduleId,
            );
            $tmp=app("L_Common_caches")->updateSetting($paramsObj);
            if($tmp["error_no"]){
                recordErrorLog($tmp); //记录错误信息
            }
        }
    }
}

if (! function_exists('addRouteModule'))
{
    /*
     * 模块增加路由
     */
    function addRouteModule($moduleId)
    {
        if($moduleId){
            $paramsObj=paramsObj();
            $paramsObj->params=array(
                "id"=>$moduleId,
            );
            $tmp=app("L_Admin_module")->routeAdd($paramsObj);
            if($tmp["error_no"]){
                recordErrorLog($tmp); //记录错误信息
            }
        }
    }
}

if (! function_exists('updateRouteModule'))
{
    /*
     * 模块更新路由
     */
    function updateRouteModule($moduleId)
    {
        if($moduleId){
            $paramsObj=paramsObj();
            $paramsObj->params=array(
                "id"=>$moduleId,
            );
            $tmp=app("L_Admin_module")->routeUpdate($paramsObj);
            if($tmp["error_no"]){
                recordErrorLog($tmp); //记录错误信息
            }
        }
    }
}

if (!function_exists('upCache')) {
    /**
     * 更新缓存
     */
    function upCache()
    {
        //更新模块缓存
        app("L_Common_caches")->initModule();
        //更新分类缓存
        app("L_Common_caches")->initCategory();
        //更新设置缓存
        app("L_Common_caches")->initSetting();
    }
}
